import com.raylib.Jaylib;
import logique.Maze;
import logique.Population;

import java.util.List;

import static com.raylib.Raylib.*;
import static com.raylib.Jaylib.BLACK;
import static com.raylib.Jaylib.RAYWHITE;

public class Main {

    public static void main(String[] args) {
        InitWindow(500, 600, "Labyrinthe");

        SetTargetFPS(100);

        Maze m = new Maze(500, 10, 0.01f, 0.7f, 0.5f);
        m.init();
        m.evaluate();
        Population p = m.getBest();
        p.setCoordinates(0, 4);
        List<Integer> moves = p.getMoves();

        long lastTime = System.currentTimeMillis();
        while (!WindowShouldClose()) {
            BeginDrawing();
            ClearBackground(RAYWHITE);

            // Draw UI
            DrawText("Generation: 1", 10, 510, 24, BLACK);
            Jaylib.Rectangle r1 = new Jaylib.Rectangle(10, 535, 150, 25);
            int btn = GuiButton(r1, "Next generation");
            GuiSetStyle(btn, TEXT_SIZE, 16);

            Jaylib.Rectangle r2 = new Jaylib.Rectangle(10, 565, 150, 25);
            int btn2 = GuiButton(r2, "Replay");
            GuiSetStyle(btn2, TEXT_SIZE, 16);



            // Draw Maze
            for (int i = 0; i < Maze.MAZE[0].length; i++) {
                for (int j = 0; j < Maze.MAZE.length; j++) {
                    if (Maze.MAZE[j][i] == 1) {
                        DrawRectangle(i * 50, j * 50, 50, 50, BLACK);
                    }
                }
            }

            p.render();
            if (System.currentTimeMillis() - lastTime > 250 && !moves.isEmpty()) {
                p.move(moves.getFirst());
                moves.removeFirst();
                lastTime = System.currentTimeMillis();
            }
            EndDrawing();
        }

        CloseWindow();
    }

}
