package logique;

import com.sun.tools.jconsole.JConsoleContext;
import utils.Pair;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;

public class Maze {

    public static int[][] MAZE = new int[][]{
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 0, 0, 0, 1, 0, 1, 0, 0, 0},
            {1, 0, 1, 0, 1, 0, 1, 0, 1, 1},
            {1, 0, 1, 0, 0, 0, 1, 0, 0, 1},
            {0, 0, 1, 1, 1, 0, 1, 1, 0, 1},
            {1, 0, 0, 0, 0, 0, 0, 1, 0, 1},
            {1, 1, 0, 1, 1, 1, 0, 1, 0, 1},
            {1, 0, 0, 0, 0, 1, 0, 1, 0, 1},
            {1, 0, 1, 1, 0, 1, 0, 0, 0, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
    };
    public static Pair<Integer, Integer> goal = new Pair<>(9, 1);

    private int populationSize;
    private int iterations;

    private float mutation;
    private float crossover;
    private float elitism;

    private final Random random = new Random();

    private List<Population> populationList;

    public Maze(int populationSize, int iterations, float mutation, float crossover, float elitism) {
        this.populationSize = populationSize;
        this.iterations = iterations;
        this.mutation = mutation;
        this.crossover = crossover;
        this.elitism = elitism;

        this.populationList = new ArrayList<>();
    }

    public void init() {
        for (int i = 0; i < populationSize; i++) {
            Population p = new Population();
            for (int j = 0; j < 40; j++) {
                p.move(random.nextInt(4));
            }
            populationList.add(p);
        }
    }

    public void evaluate() {
        populationList = populationList.stream()
                .sorted(Comparator.comparing(p -> p.score()))
                .toList();
    }

    public void createNextGeneration() {
        
    }

    public Population getBest() {
        return populationList.getFirst();
    }

    public int getPopulationSize() {
        return populationSize;
    }

    public void setPopulationSize(int populationSize) {
        this.populationSize = populationSize;
    }

    public int getIterations() {
        return iterations;
    }

    public void setIterations(int iterations) {
        this.iterations = iterations;
    }

    public float getMutation() {
        return mutation;
    }

    public void setMutation(float mutation) {
        this.mutation = mutation;
    }

    public float getCrossover() {
        return crossover;
    }

    public void setCrossover(float crossover) {
        this.crossover = crossover;
    }

    public float getElitism() {
        return elitism;
    }

    public void setElitism(float elitism) {
        this.elitism = elitism;
    }
}
